<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>NLNTransform - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="AdjustableTransform.html">AdjustableTransform</a><ul class='members'><li data-type='member' style='display: none;'><a href="AdjustableTransform.html#costs">costs</a></li><li data-type='member' style='display: none;'><a href="AdjustableTransform.html#upsilons">upsilons</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#isConnected">isConnected</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#isDependent">isDependent</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#df">df</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#df">df</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#getB">getB</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#getBValues">getBValues</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#adjust">adjust</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#adjustWeights">adjustWeights</a></li></ul></li><li><a href="BufferedOutputWeightAdjustment.html">BufferedOutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="BufferedOutputWeightAdjustment.html#setValues">setValues</a></li><li data-type='method' style='display: none;'><a href="BufferedOutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="EntropyWeightAdjustment.html">EntropyWeightAdjustment</a><ul class='members'></ul></li><li><a href="LpOutputWeightAdjustment.html">LpOutputWeightAdjustment</a><ul class='members'></ul></li><li><a href="NLNTransform.html">NLNTransform</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NLNTransform.html#createConnection">createConnection</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#getW">getW</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#h">h</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#dh">dh</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#g">g</a></li></ul></li><li><a href="OutputWeightAdjustment.html">OutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="OutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="QuadLin.html">QuadLin</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QuadLin.html#setWo">setWo</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#f">f</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#df">df</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#dw">dw</a></li></ul></li><li><a href="QuadLinOutputWeightAdjustment.html">QuadLinOutputWeightAdjustment</a><ul class='members'></ul></li><li><a href="QuadLinWeightRegularization.html">QuadLinWeightRegularization</a><ul class='members'></ul></li><li><a href="RandomOutputWeightAdjustment.html">RandomOutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="RandomOutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="RandomTransformInput.html">RandomTransformInput</a><ul class='members'></ul></li><li><a href="ReservoirTransform.html">ReservoirTransform</a><ul class='members'></ul></li><li><a href="Sigmoid.html">Sigmoid</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Sigmoid.html#f">f</a></li><li data-type='method' style='display: none;'><a href="Sigmoid.html#df">df</a></li></ul></li><li><a href="Transform.html">Transform</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Transform.html#init">init</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getParameter">getParameter</a></li><li data-type='method' style='display: none;'><a href="Transform.html#asString">asString</a></li><li data-type='method' style='display: none;'><a href="Transform.html#f">f</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getF">getF</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getFValues">getFValues</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getW">getW</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getWeights">getWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setW">setW</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getWeightsDistance">getWeightsDistance</a></li></ul></li><li><a href="TransformBuffer.html">TransformBuffer</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformBuffer.html#add">add</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#load">load</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#get">get</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getUnitCount">getUnitCount</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getTimeCount">getTimeCount</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getUnitSlice">getUnitSlice</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getTimeSlice">getTimeSlice</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getSamples">getSamples</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getChannels">getChannels</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#asString">asString</a></li></ul></li><li><a href="TransformInput.html">TransformInput</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformInput.html#setValues">setValues</a></li><li data-type='method' style='display: none;'><a href="TransformInput.html#i">i</a></li></ul></li><li><a href="TransformObserver.html">TransformObserver</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformObserver.html#add">add</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getStats">getStats</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#plotData">plotData</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#simulate">simulate</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getSpatialDivergence">getSpatialDivergence</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#asString">asString</a></li></ul></li><li><a href="WeightAdjustment.html">WeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WeightAdjustment.html#c">c</a></li><li data-type='method' style='display: none;'><a href="WeightAdjustment.html#dc">dc</a></li></ul></li><li><a href="WeightRegularization.html">WeightRegularization</a><ul class='members'><li data-type='member' style='display: none;'><a href="WeightRegularization.html#.upsilon">upsilon</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WeightRegularization.html#l">l</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">NLNTransform</h1>
    

    




<section>

<header>
    
        <h2>
        
            NLNTransform
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="NLNTransform"><span class="type-signature"></span>new NLNTransform<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Defines an input/output dynamical transform using vanilla Non-Linear Neural (NLN) network.</p>
<ul>
<li>So called NL neuron networks are made of unit of the form <br>
<code>x_n(t+1) = leak x_n(t) + (1 - leak) h(&gt;_m W_nm x_m(t))</code>.</li>
<li>The network parameters are ``W_nm`.</li>
<li>A non-linearity <code>h(·)</code> is introduced.</li>
<li>The index map is of this form:
<img src="./indexes.png" alt="indexes"></li>
<li>It implements the <a href="./Transform.html#f">f(·)</a>, and <a href="./AdjustableTransform.html#df">df(·)</a> functions.</li>
</ul>
<h4>Extends: <a href='./AdjustableTransform.html'>AdjustableTransform</a>, with all public methods available.</h4>
<h4>Extends: <a href='./TransformInput.html'>TransformInput</a>, with all public methods available.</h4></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>Object parameter, including parent class parameters:</p>
<ul>
<li><code>leak  [= 0.0]</code> Leak parameter allowing to stabilize the unit transform.</li>
<li><code>connect = true</code> If true creates <code>K</code> random network connections and initializes the weights using Wstdev.
<ul>
<li>To obtain a fully connected network, set <code>K = N * (N + Ni) - N</code>.</li>
</ul>
</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="createConnection"><span class="type-signature type-signature-protected">(protected) </span>createConnection<span class="signature">(n, m, k)</span><span class="type-signature"> &rarr; {bool}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Called by the <a href="Tranform.html#init">init()</a> routine to register connections.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The efferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>m</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The afferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>k</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The connection weight unit index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>True if the connection is created, false if the connection was already created.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">bool</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getW"><span class="type-signature type-signature-protected">(protected) </span>getW<span class="signature">(n, m)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Gets the weight value of a connection</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The efferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>m</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The afferent unit index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The weight value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="setWeights"><span class="type-signature"></span>setWeights<span class="signature">(source)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Initializes the current parameter's values from another transform.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>source</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="NLNTransform.html">NLNTransform</a></span>



            
            </td>

            

            

            <td class="description last"><p>The source transform.</p>
<ul>
<li>The source must have the same <code>N</code>, <code>T</code>, <code>K</code>, <code>Ni</code>, while <code>R = 1</code>;</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="h"><span class="type-signature type-signature-abstract">(abstract) </span>h<span class="signature">(x)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the equation non-linearity.</p>
<ul>
<li>It can be overloaded to adjust the unit not-linearity.</li>
<li>By default implements the normalised sigmoid function.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>x</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>non-linearity input.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The non-linear value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="dh"><span class="type-signature type-signature-abstract">(abstract) </span>dh<span class="signature">(x)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the equation non-linearity derivative.</p>
<ul>
<li>It can be overloaded to adjust the unit not-linearity.</li>
<li>By default implements the normalised sigmoid function derivative.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>x</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>non-linearity input.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The non-linear value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="g"><span class="type-signature"></span>g<span class="signature">(n, s)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Computes the unit linear combination.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>s</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Time to consider.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The <code>&gt;_m W_nm x_m(s)</code> value.</p>
</div>



    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>